function c = maxLoglikByLineSearch(X, a, b, choiceModel)
    
    func = @(c)-computeLoglik(X * c, a, b,  choiceModel);
    m = 1e-6;
    n = 100;
    
    const = (-1+sqrt(5))/2;
    x1 = const*m + (1-const)*n;
    fx1 = feval(func,x1);
    x2 = (1-const)*m + const*n;
    fx2 = feval(func,x2);
    for i = 1:10000
        if fx1 < fx2
            n = x2;
            x2 = x1;
            fx2 = fx1;
            x1 = const*m + (1-const)*n;
            fx1 = feval(func,x1);
        else
            m = x1;
            x1 = x2;
            fx1 = fx2;
            x2 = (1-const)*m + const*n;
            fx2 = feval(func,x2);
        end;
        if (abs(n-m) < eps)
            break;
        end;
    end;
    c = (m+n)/2;